"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _react2 = require("@mdi/react");

var _js = require("@mdi/js");

var _rRangeSlider = _interopRequireDefault(require("r-range-slider"));

var _aioButton = _interopRequireDefault(require("aio-button"));

var _aioValidation = _interopRequireDefault(require("aio-validation"));

var _aioTable = _interopRequireDefault(require("./aio-table/aio-table"));

var _reactVirtualDom = _interopRequireDefault(require("react-virtual-dom"));

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

class AIOForm extends _react.Component {
  constructor(props) {
    super(props);
    let {
      model,
      theme = {}
    } = this.props;
    this.state = {
      initialModel: JSON.stringify(model),
      model,
      theme
    };
  }

  getModel() {
    return this.props.onSubmit ? this.state.model : this.props.model;
  }

  getValue(field, def, props = this.props) {
    let model = this.getModel(),
        {
      data = {}
    } = this.props,
        a;

    if (typeof field === 'string' && field.indexOf('calc ') === 0) {
      try {
        a = eval(field.slice(5, field.length));
      } catch {
        a = def;
      }
    } else {
      a = field;
    }

    return a;
  }

  setValue(field, value, model = this.getModel()) {
    eval(`model.${field} = value`);
    return model;
  }

  onChange(input, value) {
    let {
      onChange,
      onSubmit
    } = this.props;

    if (onSubmit) {
      this.setState({
        model: this.setValue(input.field, value)
      });
    } else {
      if (input.onChange) {
        return input.onChange(value);
      }

      onChange(this.setValue(input.field, value));
    }
  }

  getInputTheme(input) {
    let {
      theme: stateTheme = {}
    } = this.state;
    let {
      theme: inputTheme = {}
    } = input;
    return { ...stateTheme,
      ...inputTheme
    };
  }

  getInput_text({
    className,
    value,
    onChange,
    options,
    disabled,
    style,
    placeholder
  }, input) {
    let props = { ...input.attrs,
      autoHeight: input.autoHeight,
      type: input.type,
      value,
      className,
      onChange,
      options,
      disabled,
      style,
      placeholder,
      options
    };
    return /*#__PURE__*/_react.default.createElement(Text, props);
  }

  getInput_number(obj, input) {
    return this.getInput_text(obj, input);
  }

  getInput_password(obj, input) {
    return this.getInput_text(obj, input);
  }

  getInput_textarea(obj, input) {
    return this.getInput_text(obj, input);
  }

  getInput_checkbox({
    className,
    onChange,
    value,
    disabled,
    style,
    text,
    subtext,
    theme
  }, input) {
    let props = {
      disabled,
      style,
      value,
      subtext: input.subText,
      text,
      subtext,
      onChange: value => onChange(!value),
      className,
      iconSize: theme.checkIconSize,
      iconColor: theme.checkIconColor
    };
    return /*#__PURE__*/_react.default.createElement(_aioButton.default, _extends({}, props, {
      type: "checkbox"
    }));
  }

  getInput_checklist({
    className,
    options: Options,
    disabled,
    style,
    theme
  }, input) {
    let options = Options.map(o => {
      let model = this.getModel(),
          value = this.getValue('calc model.' + o.field),
          text = o.text;
      return {
        text,
        value,
        onChange: (val, obj) => {
          this.onChange({
            field: o.field,
            onChange: o.onChange
          }, !val);
        },
        ...o
      };
    });
    let {
      input: inputTheme = {}
    } = theme;
    let props = {
      options,
      disabled,
      style,
      optionSubtext: input.optionSubtext,
      className,
      options,
      optionClassName: '"aio-form-input"',
      optionStyle: () => {
        return {
          width: input.optionWidth || 'fit-content',
          height: inputTheme.height,
          padding: inputTheme.padding,
          background: 'none'
        };
      },
      optionIconSize: theme.checkIconSize,
      optionIconColor: theme.checkIconColor
    };
    return /*#__PURE__*/_react.default.createElement(_aioButton.default, _extends({}, props, {
      type: "checklist"
    }));
  }

  getInput_radio({
    value,
    onChange,
    options,
    disabled,
    style,
    className,
    theme
  }, input) {
    let {
      input: inputTheme = {}
    } = theme;
    let props = {
      options,
      value,
      onChange,
      disabled,
      style,
      optionSubtext: input.optionSubtext,
      optionText: input.optionText,
      optionValue: input.optionValue,
      className,
      optionClassName: '"aio-form-input"',
      optionStyle: () => {
        return {
          width: input.optionWidth || 'fit-content',
          height: inputTheme.height,
          padding: inputTheme.padding,
          background: 'none'
        };
      },
      optionIconSize: theme.checkIconSize,
      optionIconColor: theme.checkIconColor
    };
    return /*#__PURE__*/_react.default.createElement(_aioButton.default, _extends({}, props, {
      type: "radio"
    }));
  }

  getInput_slider({
    className,
    value,
    onChange,
    disabled,
    style,
    start,
    end
  }, input) {
    let editValue;

    if (typeof input.editValue === 'string') {
      let str = input.editValue;

      if (str.indexOf('calc ') === 0) {
        str = str.slice(5, str.length);
      }

      editValue = value => {
        let res;

        try {
          eval(`res = ${str}`);
        } catch {
          res = value;
        }

        return res;
      };
    } else {
      editValue = input.editValue;
    }

    let props = {
      className,
      value,
      onChange,
      start,
      end,
      step: input.step,
      disabled,
      style,
      editValue
    };
    return /*#__PURE__*/_react.default.createElement(AIOFormSlider, props);
  }

  getInput_select({
    className,
    value,
    onChange,
    options,
    disabled,
    style
  }, input) {
    let props = {
      options,
      value,
      onChange,
      className,
      search: input.search,
      disabled,
      style,
      optionText: input.optionText,
      optionValue: input.optionValue,
      optionBefore: input.optionBefore,
      optionAfter: input.optionAfter,
      text: input.text,
      before: input.before,
      optionSubtext: input.optionSubtext
    };
    return /*#__PURE__*/_react.default.createElement(_aioButton.default, _extends({}, props, {
      type: "select",
      popupWidth: "fit",
      popupAttrs: {
        style: {
          maxHeight: 400
        }
      }
    }));
  }

  getInput_multiselect({
    className,
    value,
    onChange,
    options,
    disabled,
    style,
    text,
    subtext,
    theme
  }, input) {
    let props = {
      className,
      value,
      onChange,
      options,
      text,
      subtext,
      disabled,
      search: input.search,
      style,
      popupWidth: 'fit',
      optionText: input.optionText,
      optionValue: input.optionValue,
      optionBefore: input.optionBefore,
      optionAfter: input.optionAfter,
      text: input.text,
      before: input.before,
      optionSubtext: input.optionSubtext,
      optionIconSize: theme.checkIconSize,
      optionIconColor: theme.checkIconColor
    };
    return /*#__PURE__*/_react.default.createElement(_aioButton.default, _extends({}, props, {
      type: "multiselect",
      popupAttrs: {
        style: {
          maxHeight: 400
        }
      }
    }));
  }

  getInput_table({
    className,
    value,
    onChange,
    disabled,
    style
  }, input) {
    let props = {
      attrs: input.attrs,
      className,
      value,
      onChange,
      columns: input.columns,
      addable: input.addable,
      rowNumber: input.rowNumber,
      disabled,
      style
    };
    return /*#__PURE__*/_react.default.createElement(AIOFormTable, _extends({}, props, {
      getValue: this.getValue.bind(this)
    }));
  }

  getInput_splitter(obj, input) {
    return /*#__PURE__*/_react.default.createElement("div", {
      style: {
        height: 48,
        width: '100%',
        display: 'flex',
        alignItems: 'center'
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      style: {
        height: 0,
        flex: 1,
        borderBottom: '1px solid #bbb'
      }
    }), /*#__PURE__*/_react.default.createElement("div", {
      style: {
        padding: '0 6px',
        color: '#aaa'
      }
    }, "msf"), /*#__PURE__*/_react.default.createElement("div", {
      style: {
        height: 0,
        flex: 1,
        borderBottom: '1px solid #bbb'
      }
    }));
  }

  sortByRows(inputs) {
    let res = {};
    let result = [];

    for (let i = 0; i < inputs.length; i++) {
      let {
        type,
        show
      } = inputs[i];

      if (!type) {
        continue;
      }

      if (this.getValue(show, true) === false) {
        continue;
      }

      inputs[i]._index = i;

      if (type === 'group') {
        let a = 'a' + Math.random();
        res[a] = [inputs[i]];
        result.push(res[a]);
        continue;
      }

      let {
        rowKey
      } = inputs[i];

      if (!rowKey) {
        rowKey = 'a' + Math.random();
      }

      if (!res[rowKey]) {
        res[rowKey] = [];
        result.push(res[rowKey]);
      }

      res[rowKey].push(inputs[i]);
    }

    return result;
  }

  getFix(input, rtl, type) {
    let fix_props = this.props[type + 'Attrs'] || {};
    let fix_input = input[type + 'Attrs'] || {};
    let attrs = { ...fix_props,
      ...fix_input
    };
    let {
      onClick = () => {}
    } = attrs;
    return /*#__PURE__*/_react.default.createElement("div", _extends({}, attrs, {
      onClick: () => onClick(input),
      className: `aio-form-${type}` + (rtl ? ' rtl' : '') + (attrs.className ? ' ' + attrs.className : '')
    }), input[type]);
  }

  getInput(input) {
    let {
      rtl
    } = this.props;
    let {
      label,
      affix,
      prefix,
      prefixAttrs = {}
    } = input;
    let theme = this.getInputTheme(input);
    let value = this.getValue('calc model.' + input.field);
    let options = this.getValue(input.options, []);
    let disabled = this.getValue(input.disabled, false);
    let text = this.getValue(input.text);
    let start = this.getValue(input.start, 0);
    let end = this.getValue(input.end, 100);
    let subtext = this.getValue(input.subtext);
    let placeholder = this.getValue(input.placeholder, false);

    let onChange = value => this.onChange(input, value);

    let style = theme.input;
    let className = `aio-form-input aio-form-input-${input.type}` + (disabled ? ' disabled' : '') + (input.className ? ' ' + input.className : '') + (affix ? ' has-affix' : '') + (prefix ? ' has-prefix' : '') + (rtl ? ' rtl' : ' ltr');
    let error = this.getError(input, value, options);
    let props = {
      value,
      options,
      disabled,
      onChange,
      className,
      style,
      placeholder,
      text,
      subtext,
      start,
      end,
      theme
    };
    let {
      label: themeLabel = {}
    } = theme;

    if (themeLabel.inline) {
      return {
        className: 'aio-form-item',
        style: {
          overflow: 'visible',
          marginBottom: theme.rowGap
        },
        row: [{
          align: 'v',
          size: themeLabel.width,
          show: label !== undefined,
          html: label,
          style: { ...themeLabel,
            width: 'fit-content'
          }
        }, {
          size: 6
        }, {
          flex: 1,
          style: {
            overflow: 'visible'
          },
          column: [{
            row: [{
              show: !!input.prefix,
              html: () => this.getFix(input, rtl, 'prefix')
            }, {
              flex: 1,
              html: () => this['getInput_' + input.type](props, input)
            }, {
              show: !!input.affix,
              html: () => this.getFix(input, rtl, 'affix')
            }]
          }, {
            align: 'v',
            show: error !== '',
            html: error,
            className: 'aio-form-error'
          }]
        }]
      };
    } else {
      return {
        className: 'aio-form-item',
        style: {
          overflow: 'visible',
          marginBottom: theme.rowGap
        },
        column: [{
          size: themeLabel.height || 24,
          show: label !== undefined,
          align: 'v',
          html: label,
          style: { ...themeLabel,
            width: 'fit-content',
            height: 'fit-content'
          }
        }, {
          row: [{
            show: !!input.prefix,
            html: () => this.getFix(input, rtl, 'prefix')
          }, {
            flex: 1,
            html: () => this['getInput_' + input.type](props, input)
          }, {
            show: !!input.affix,
            html: () => this.getFix(input, rtl, 'affix')
          }]
        }, {
          size: 24,
          show: error !== '',
          html: error,
          className: 'aio-form-error'
        }]
      };
    }
  }

  getInputs(inputs) {
    let {
      onSwap
    } = this.props;
    let {
      theme
    } = this.state;
    return this.sortByRows(inputs).map((input, i) => {
      return {
        swapId: onSwap ? input._index.toString() : undefined,
        swapHandleClassName: 'aio-form-label',
        gap: theme.columnGap || 12,
        row: input.map(o => {
          return { ...this.getInput(o),
            flex: o.rowWidth ? undefined : 1,
            size: o.rowWidth,
            align: 'v'
          };
        })
      };
    });
  }

  getError(o, value, options) {
    let {
      validations = []
    } = o;
    let lang = 'en';

    if (!validations.length) {
      return '';
    }

    let a = {
      value,
      title: o.label,
      lang,
      validations: validations.map(a => {
        return [a[0], this.getValue(a[1], ''), a[2]];
      })
    };
    let error = (0, _aioValidation.default)(a);

    if (!this.isThereError && error) {
      this.isThereError = true;
    }

    return error;
  }

  async reset() {
    let {
      onSubmit,
      onChange
    } = this.props;
    let {
      initialModel
    } = this.state;

    if (onSubmit) {
      this.setState({
        model: JSON.parse(initialModel)
      });
    } else if (onChange) {
      await onChange(JSON.parse(initialModel));
    }
  }

  render() {
    let {
      inputs,
      header,
      rtl,
      onSubmit,
      submitText = 'Submit',
      closeText = 'Close',
      resetText = 'Reset',
      onClose,
      footerAttrs,
      reset
    } = this.props;
    this.isThereError = false;
    let column = this.getInputs(inputs);
    return /*#__PURE__*/_react.default.createElement(_reactVirtualDom.default, {
      layout: {
        className: 'aio-form',
        column: [{
          show: header !== undefined,
          html: /*#__PURE__*/_react.default.createElement(AIOFormHeader, _extends({}, header, {
            rtl: rtl
          }))
        }, {
          className: 'aio-form-body',
          scroll: 'v',
          flex: 1,
          column
        }, {
          show: onSubmit !== undefined || reset === true || onClose !== undefined,
          html: () => /*#__PURE__*/_react.default.createElement(AIOFormFooter, {
            isThereError: this.isThereError,
            onClose: onClose,
            onSubmit: onSubmit ? () => onSubmit({ ...this.state.model
            }) : undefined,
            closeText: closeText,
            submitText: submitText,
            resetText: resetText,
            footerAttrs: footerAttrs,
            onReset: reset ? () => this.reset() : undefined
          })
        }]
      }
    });
  }

}

exports.default = AIOForm;

class AIOFormHeader extends _react.Component {
  render() {
    let {
      title,
      subtitle,
      onClose,
      attrs = {},
      print,
      onBack,
      justify,
      onForward,
      rtl
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactVirtualDom.default, {
      layout: {
        className: 'aio-form-header' + (attrs.className ? ' ' + attrs.className : ''),
        style: attrs.style,
        align: 'v',
        row: [{
          show: onBack !== undefined,
          html: /*#__PURE__*/_react.default.createElement(_react2.Icon, {
            path: rtl ? _js.mdiChevronRight : _js.mdiChevronLeft,
            size: 0.9
          }),
          align: 'vh',
          size: 36,
          attrs: {
            onClick: onBack
          }
        }, {
          show: justify === true,
          flex: 1
        }, {
          column: [{
            html: title,
            className: 'aio-form-title',
            align: 'v'
          }, {
            show: subtitle !== undefined,
            html: subtitle,
            className: 'aio-form-subtitle',
            align: 'v'
          }]
        }, {
          flex: 1
        }, {
          show: onForward !== undefined,
          html: /*#__PURE__*/_react.default.createElement(_react2.Icon, {
            path: rtl ? _js.mdiChevronLeft : _js.mdiChevronRight,
            size: 0.9
          }),
          align: 'vh',
          size: 36,
          attrs: {
            onClick: onForward
          }
        }, {
          show: print !== undefined,
          html: /*#__PURE__*/_react.default.createElement(_react2.Icon, {
            path: _js.mdiPrinter,
            size: 0.9
          }),
          align: 'vh',
          size: 36
        }, {
          show: onClose !== undefined,
          html: /*#__PURE__*/_react.default.createElement(_react2.Icon, {
            path: _js.mdiClose,
            size: 0.8
          }),
          align: 'vh',
          size: 36,
          attrs: {
            onClick: onClose
          }
        }]
      }
    });
  }

}

class AIOFormFooter extends _react.Component {
  render() {
    let {
      onClose,
      onSubmit,
      closeText,
      submitText,
      footerAttrs = {},
      onReset,
      resetText,
      isThereError
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactVirtualDom.default, {
      layout: {
        align: 'v',
        className: 'aio-form-footer',
        row: [{
          show: onClose !== undefined,
          html: () => /*#__PURE__*/_react.default.createElement("button", {
            className: "aio-form-footer-button aio-form-close-button",
            onClick: () => onClose()
          }, closeText)
        }, {
          size: 12,
          show: onSubmit !== undefined
        }, {
          show: onSubmit !== undefined,
          html: () => /*#__PURE__*/_react.default.createElement("button", {
            className: "aio-form-footer-button aio-form-submit-button",
            disabled: isThereError,
            onClick: () => onSubmit()
          }, submitText)
        }, {
          size: 12,
          show: onSubmit !== undefined
        }, {
          show: onReset !== undefined,
          html: () => /*#__PURE__*/_react.default.createElement("button", {
            className: "aio-form-footer-button aio-form-reset-button",
            onClick: () => onReset()
          }, resetText)
        }]
      }
    });
  }

}

function Text(obj) {
  let [value, setValue] = (0, _react.useState)(obj.value),
      [prevValue, setPrevValue] = (0, _react.useState)(obj.value),
      [timer, setTimer] = (0, _react.useState)();
  let [error, setError] = (0, _react.useState)(false);
  let dom = (0, _react.useRef)(null);

  if (obj.value !== prevValue) {
    setTimeout(() => {
      setValue(obj.value);
      setPrevValue(obj.value);
    }, 0);
  }

  function onChange(e) {
    let value = e.target.value;

    if (obj.type === 'number') {
      if (value) {
        value = +value;
      }
    }

    setValue(value);
    clearTimeout(timer);
    setTimer(setTimeout(() => {
      obj.onChange(value);
    }, 800));
  }

  (0, _react.useEffect)(() => {
    if (obj.type === 'textarea' && obj.autoHeight) {
      let scrollHeight = dom.current.scrollHeight + 'px';
      dom.current.style.height = scrollHeight;
      dom.current.style.overflow = 'hidden';
      dom.current.style.resize = 'none';
    }
  });
  let props = { ...obj,
    value,
    onChange: e => onChange(e),
    ref: dom
  };
  let uid = 'a' + Math.random();

  if (error !== false) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "aio-form-inline-error aio-form-input",
      onClick: () => setError(false)
    }, error);
  }

  return obj.type === 'textarea' ? /*#__PURE__*/_react.default.createElement("textarea", props) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("input", _extends({}, props, {
    list: uid
  })), Array.isArray(obj.options) && obj.options.length !== 0 && /*#__PURE__*/_react.default.createElement("datalist", {
    id: uid
  }, obj.options.map((o, i) => /*#__PURE__*/_react.default.createElement("option", {
    key: i,
    value: o.text
  }))));
}

class AIOFormSlider extends _react.Component {
  render() {
    let {
      className,
      start,
      end,
      step,
      value,
      onChange,
      disabled,
      style,
      editValue
    } = this.props;

    if (!Array.isArray(value)) {
      value = [value];
    }

    let props = {
      attrs: {
        className,
        style
      },
      start,
      end,
      step,
      points: value,
      onChange: disabled ? undefined : points => points.length === 1 ? onChange(points[0]) : onChange([points[0], points[1]]),
      showValue: true,
      editValue,
      fillStyle: index => {
        if (value.length === 1) {
          if (index === 1) {
            return {
              background: 'none'
            };
          }
        } else {
          if (index === 0 || index === value.length) {
            return {
              background: 'none'
            };
          }
        }

        return {
          background: 'dodgerblue'
        };
      },
      valueStyle: () => {
        return {
          height: 20,
          display: 'flex',
          minWidth: 12,
          padding: '0 3px',
          justifyContent: 'center',
          alignItems: 'center',
          top: 'calc(50% - 10px)'
        };
      },
      pointStyle: () => {
        return {
          display: 'none'
        };
      }
    };
    return /*#__PURE__*/_react.default.createElement(_rRangeSlider.default, props);
  }

}

class AIOFormTable extends _react.Component {
  setValueByField(obj, field, value) {
    field = field.replaceAll('[', '.');
    field = field.replaceAll(']', '');
    var fields = field.split('.');
    var node = obj;

    for (let i = 0; i < fields.length - 1; i++) {
      if (node[fields[i]] === undefined) {
        if (isNaN(parseFloat(fields[i + 1]))) {
          node[fields[i]] = {};
        } else {
          node[fields[i]] = [];
        }

        node = node[fields[i]];
      } else {
        node = node[fields[i]];
      }
    }

    node[fields[fields.length - 1]] = value;
    return obj;
  }

  add() {
    let {
      columns = [],
      onChange,
      value = []
    } = this.props;

    if (!columns.length) {
      return;
    }

    let obj = {};

    for (let i = 0; i < columns.length; i++) {
      let {
        field,
        type
      } = columns[i];

      if (!field) {
        continue;
      }

      if (typeof field === 'string' && field.indexOf('calc ') === 0) {
        continue;
      }

      let val;

      if (type === 'text') {
        val = '';
      } else if (type === 'number') {
        val = 0;
      } else if (type === 'select') {
        let options = this.getColumnOptions(columns[i]);

        try {
          val = options[0].value;
        } catch {
          val = '';
        }
      } else if (type === 'checkbox') {
        val = false;
      }

      this.setValueByField(obj, field, val);
    }

    value.push(obj);
    onChange(value);
  }

  getToolbarItems() {
    let {
      item,
      addable = true,
      disabled
    } = this.props;

    if (disabled) {
      return;
    }

    let toolbarItems = [];

    if (addable) {
      toolbarItems.push({
        text: '+',
        type: 'button',
        onClick: () => this.add(),
        className: 'aio-form-input aio-form-input-table-add',
        style: {
          background: 'none',
          color: 'inherit',
          padding: 0,
          width: '100%'
        }
      });
    }

    return toolbarItems;
  }

  getColumnOptions(column) {
    let {
      getValue
    } = this.props;
    return getValue(column.options, []);
  }

  getColumns() {
    let {
      onChange,
      addable = true,
      disabled,
      columns,
      value,
      rowNumber
    } = this.props;
    let result = columns.map(column => {
      let a = { ...column,
        cellAttrs: {
          className: 'aio-form-input'
        },
        titleAttrs: {
          className: 'aio-form-input'
        },
        getValue: column.field.indexOf('calc ') === 0 ? row => {
          let a;
          column.disabled = true;

          try {
            a = eval(column.field.slice(5, column.field.length));
          } catch {
            a = '';
          }

          return a;
        } : column.field
      };

      if (column.type === 'select') {
        let options = this.getColumnOptions(column);

        a.template = (row, column, value) => {
          let option = options.filter(o => o.value === value)[0];
          return option ? option.text : '';
        };
      }

      if (column.type === 'checkbox') {
        let options = this.getColumnOptions(column) || [{
          text: 'True',
          value: true
        }, {
          text: 'False',
          value: false
        }];

        a.template = (row, column, value) => {
          let option = options.filter(o => o.value === value)[0];
          return option ? option.text : '';
        };
      }

      if (['text', 'number', 'select', 'checkbox'].indexOf(column.type) !== -1 && !disabled) {
        a.inlineEdit = {
          type: column.type,
          disabled: column.disabled,
          onChange: (row, val) => {
            if (!value[row._index]) {
              value[row._index] = {};
            }

            this.setValueByField(value[row._index], column.field, val);
            onChange(value);
          },
          disabled: () => disabled
        };

        if (column.type === 'select') {
          a.inlineEdit.options = this.getColumnOptions(column);
        }

        a.inlineEdit.disabled = row => {
          if (column.disabled) {
            return true;
          }

          return false;
        };
      }

      return a;
    });

    if (rowNumber) {
      result.splice(0, 0, {
        title: '#',
        width: 48,
        getValue: ({
          _index
        }) => _index + 1,
        cellAttrs: {
          className: 'aio-form-input'
        },
        titleAttrs: {
          className: 'aio-form-input'
        }
      });
    }

    if (addable && !disabled) {
      result.push({
        title: '',
        width: 36,
        cellAttrs: {
          className: 'aio-form-input'
        },
        titleAttrs: {
          className: 'aio-form-input'
        },
        template: row => {
          return /*#__PURE__*/_react.default.createElement("div", {
            onClick: () => {
              let {
                value
              } = this.props;
              value.splice(row._index, 1);
              onChange(value);
            }
          }, "X");
        }
      });
    }

    return result;
  }

  render() {
    let {
      value = [],
      disabled,
      className,
      style,
      attrs
    } = this.props;
    let model;
    let input = {
      height: 28
    };

    try {
      model = JSON.parse(JSON.stringify(value));
    } catch {
      model = [];
    }

    if (!model.length) {
      if (disabled) {
        return null;
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "aio-form-table-add aio-form-input",
        onClick: () => this.add()
      }, "+");
    }

    let columns = this.getColumns();
    let props = {
      getCellStyle: () => {
        return style;
      },
      titleStyle: style,
      disabled,
      className,
      columns,
      toolbarItems: this.getToolbarItems(),
      columns,
      model: value,
      style: attrs ? attrs.style : undefined
    };
    return /*#__PURE__*/_react.default.createElement(_aioTable.default, {
      columns: props.columns,
      model: props.model,
      rowGap: 0,
      toolbarItems: props.toolbarItems,
      toolbarAttrs: {
        className: 'aio-form-input',
        style: {
          border: 'none',
          display: disabled ? 'none' : undefined
        }
      },
      style: props.style
    });
  }

}